{
    "scan": {
        "analyzer-version-clang": "18.1.2",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-78.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "xz-5.4.6-3.fc40",
        "store-results-to": "/tmp/tmprb0gt1oj/xz-5.4.6-3.fc40.tar.xz",
        "time-created": "2024-04-17 06:15:35",
        "time-finished": "2024-04-17 06:18:24",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'shellcheck,clang,cppcheck,gcc' '-o' '/tmp/tmprb0gt1oj/xz-5.4.6-3.fc40.tar.xz' '--gcc-analyze' '/tmp/tmprb0gt1oj/xz-5.4.6-3.fc40.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 758,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/etc/profile.d/colorxzgrep.sh",
                    "line": 1,
                    "column": 1,
                    "event": "error[SC2148]",
                    "message": "Tips depend on target shell and yours is unknown. Add a shebang or a 'shell' directive.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    1|-> /usr/libexec/grepconf.sh -c || return",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    2|   alias xzgrep='xzgrep --color=auto' 2>/dev/null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    3|   alias xzegrep='xzegrep --color=auto' 2>/dev/null",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 569,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzdiff",
                    "line": 65,
                    "column": 25,
                    "event": "warning[SC2188]",
                    "message": "This redirection doesn't have a command. Move to its command (or use 'true' as no-op).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   63|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   64|   for file; do",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   65|->   test \"X$file\" = X- || <\"$file\" || exit 2",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   66|   done",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 563,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzdiff",
                    "line": 100,
                    "column": 7,
                    "event": "warning[SC2034]",
                    "message": "FILE appears unused. Verify use (or export if used externally).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|         FILE=`expr \"X$1\" : 'X\\(.*[-.]t\\)zo$'`ar;;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   99|       *.tzst)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  100|->       FILE=`expr \"X$1\" : 'X\\(.*[-.]t\\)zst$'`ar;;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  101|     esac",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  102|     xz_status=$(",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 569,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzless",
                    "line": 47,
                    "column": 30,
                    "event": "warning[SC2089]",
                    "message": "Quotes/backslashes will be treated literally. Rewrite using set/\"$@\" or functions.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|   \tnl='",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   '",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|-> \tLESSMETACHARS=\"$space$tab$nl'\"';*?\"()<>[|&^`#\\$%=~'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 569,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzless",
                    "line": 57,
                    "column": 8,
                    "event": "warning[SC2090]",
                    "message": "Quotes/backslashes in this variable will not be respected.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   55|   \tLESSOPEN=\"|$xz -cdfqQ -- %s\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   56|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   57|-> export LESSMETACHARS LESSOPEN",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   exec less \"$@\"",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 46,
                    "column": 46,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|   if test $? -eq 0 && test -n \"$oldtty\"; then",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|-> \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|   \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 46,
                    "column": 48,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|   if test $? -eq 0 && test -n \"$oldtty\"; then",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|-> \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|   \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 46,
                    "column": 51,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|   if test $? -eq 0 && test -n \"$oldtty\"; then",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|-> \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|   \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 48,
                    "column": 48,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|-> \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 48,
                    "column": 50,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|-> \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 398,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 48,
                    "column": 53,
                    "event": "warning[SC2172]",
                    "message": "Trapping signals by number is not well defined. Prefer signal names.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   \ttrap 'stty $oldtty 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|-> \ttrap 'stty $ncb echo 2>/dev/null; exit' 0 2 3 5 10 13 15",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|   fi",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 569,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/xzmore",
                    "line": 60,
                    "column": 3,
                    "event": "warning[SC2188]",
                    "message": "This redirection doesn't have a command. Move to its command (or use 'true' as no-op).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|   \tFIRST=1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   \tfor FILE; do",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   60|-> \t\t< \"$FILE\" || continue",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   \t\tif test $FIRST -eq 0; then",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|   \t\t\tprintf \"%s--More--(Next file: %s)\" \"\" \"$FILE\"",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘tuklib_open_stdxxx’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 41,
                    "column": 28,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", <unknown>)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 31,
                    "column": 27,
                    "event": "note",
                    "message": "(1) following ‘true’ branch (when ‘i != 3’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 33,
                    "column": 21,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 33,
                    "column": 20,
                    "event": "note",
                    "message": "(3) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 38,
                    "column": 40,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 38,
                    "column": 40,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘i == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 38,
                    "column": 40,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 38,
                    "column": 40,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/common/tuklib_open_stdxxx.c",
                    "line": 41,
                    "column": 28,
                    "event": "note",
                    "message": "(8) ‘open(\"/dev/null\", <unknown>)’ leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39|   \t\t\t\t\t| (i == 0 ? O_WRONLY : O_RDONLY));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   40|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   41|-> \t\t\tif (fd != i) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   42|   \t\t\t\tif (fd != -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   43|   \t\t\t\t\t(void)close(fd);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_mt_block_size'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 259,
                    "column": 23,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL '0'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 252,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'lzma_mt_block_size'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 256,
                    "column": 42,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 258,
                    "column": 35,
                    "event": "note",
                    "message": "(4) inlined call to 'encoder_find' from 'lzma_mt_block_size'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 178,
                    "column": 30,
                    "event": "note",
                    "message": "(5) following 'true' branch (when 'i != 11')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 179,
                    "column": 32,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 179,
                    "column": 20,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 178,
                    "column": 54,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_mt_block_size'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/filter_encoder.c",
                    "line": 259,
                    "column": 23,
                    "event": "note",
                    "message": "(9) dereference of NULL '<unknown>'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  257|   \t\tconst lzma_filter_encoder *const fe",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  258|   \t\t\t\t= encoder_find(filters[i].id);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  259|-> \t\tif (fe->block_size != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  260|   \t\t\tconst uint64_t size",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|   \t\t\t\t\t= fe->block_size(filters[i].options);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 266,
                    "column": 11,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'parent' results in a dereference of a null pointer (loaded from variable 'node')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 948,
                    "column": 21,
                    "event": "note",
                    "message": "Calling 'index_init_plain'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 384,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'i' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 384,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 385,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 187,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to field 'rightmost'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 385,
                    "column": 3,
                    "event": "note",
                    "message": "Returning from 'index_tree_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 948,
                    "column": 21,
                    "event": "note",
                    "message": "Returning from 'index_init_plain'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 949,
                    "column": 6,
                    "event": "note",
                    "message": "'dest' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 949,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 7,
                    "event": "note",
                    "message": "'deststream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 233,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to field 'parent'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 12,
                    "event": "note",
                    "message": "Field 'root' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Returning from 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 972,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'srcstream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 961,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 962",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'deststream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 12,
                    "event": "note",
                    "message": "Field 'root' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 261,
                    "column": 31,
                    "event": "note",
                    "message": "Assuming right operand of bit shift is less than 32",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/stdint.h",
                    "line": 249,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'UINT32_C'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<scratch space>",
                    "line": 165,
                    "column": 1,
                    "event": "note",
                    "message": "expanded from here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 262,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'up' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 262,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 267,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 266",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 266,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer value stored to 'node'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 267,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 266",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 266,
                    "column": 11,
                    "event": "note",
                    "message": "Access to field 'parent' results in a dereference of a null pointer (loaded from variable 'node')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \t\tup = ctz32(tree->count) + 2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|   \t\tdo {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  266|-> \t\t\tnode = node->parent;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  267|   \t\t} while (--up > 0);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  268|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 270,
                    "column": 28,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'right' results in a dereference of a null pointer (loaded from variable 'node')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 948,
                    "column": 21,
                    "event": "note",
                    "message": "Calling 'index_init_plain'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 384,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'i' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 384,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 385,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 187,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to field 'rightmost'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 385,
                    "column": 3,
                    "event": "note",
                    "message": "Returning from 'index_tree_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 948,
                    "column": 21,
                    "event": "note",
                    "message": "Returning from 'index_init_plain'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 949,
                    "column": 6,
                    "event": "note",
                    "message": "'dest' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 949,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 7,
                    "event": "note",
                    "message": "'deststream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 233,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to field 'parent'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 12,
                    "event": "note",
                    "message": "Field 'root' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Returning from 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 972,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'srcstream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 961,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 962",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'deststream' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 964,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 969,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'index_tree_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 12,
                    "event": "note",
                    "message": "Field 'root' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 240,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 261,
                    "column": 31,
                    "event": "note",
                    "message": "Assuming right operand of bit shift is less than 32",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/stdint.h",
                    "line": 249,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'UINT32_C'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<scratch space>",
                    "line": 165,
                    "column": 1,
                    "event": "note",
                    "message": "expanded from here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 262,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'up' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 262,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 267,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 266",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 266,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer value stored to 'node'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 267,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 270,
                    "column": 28,
                    "event": "note",
                    "message": "Access to field 'right' results in a dereference of a null pointer (loaded from variable 'node')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  268|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  269|   \t\t// Rotate left using node as the rotation root.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  270|-> \t\tindex_tree_node *pivot = node->right;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \t\tif (node->parent == NULL) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 319,
                    "column": 32,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'result'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_index_iter_locate'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1229,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'lzma_index_iter_locate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1234,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1238,
                    "column": 38,
                    "event": "note",
                    "message": "(3) inlined call to 'index_tree_locate' from 'lzma_index_iter_locate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 319,
                    "column": 32,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_index_iter_locate'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1243,
                    "column": 36,
                    "event": "note",
                    "message": "(5) inlined call to 'index_tree_locate' from 'lzma_index_iter_locate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 319,
                    "column": 32,
                    "event": "note",
                    "message": "(6) dereference of NULL 'result'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  317|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  318|   \tconst index_tree_node *result = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  319|-> \tconst index_tree_node *node = tree->root;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  320|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  321|   \tassert(tree->leftmost == NULL",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_index_iter_locate'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1252,
                    "column": 16,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'result'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1229,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'lzma_index_iter_locate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1234,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1238,
                    "column": 38,
                    "event": "note",
                    "message": "(3) inlined call to 'index_tree_locate' from 'lzma_index_iter_locate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 319,
                    "column": 32,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 326,
                    "column": 21,
                    "event": "note",
                    "message": "(5) following 'true' branch (when 'node' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 327,
                    "column": 25,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lzma_index_iter_locate'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "xz-5.4.6/src/liblzma/common/index.c",
                    "line": 1252,
                    "column": 16,
                    "event": "note",
                    "message": "(7) dereference of NULL 'result'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1250|   \t// we don't want to return them.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1251|   \tsize_t left = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1252|-> \tsize_t right = group->last;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1253|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1254|   \twhile (left < right) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 97,
                    "column": 13,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 651,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'name' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 651,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 662,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 662,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 665,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 665,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 667,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 667,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 671,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 671,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 674,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 674,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 684,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'parse_real'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 235,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 235,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 237,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case OPT_BLOCK_LIST:'  at line 498",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 499,
                    "column": 4,
                    "event": "note",
                    "message": "Calling 'parse_block_list'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 76,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 76,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 76,
                    "column": 24,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 76,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 81,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 82,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 81,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 81,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 82,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 82,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 81,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 81,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 86",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 86,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 95,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 97,
                    "column": 3,
                    "event": "note",
                    "message": "'p' initialized here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 98,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'p' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 98,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 101,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 114,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 114,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 124,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 95,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xz/args.c",
                    "line": 97,
                    "column": 13,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   \tfor (size_t i = 0; i < count; ++i) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   \t\t// Locate the next comma and replace it with \\0.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|-> \t\tchar *p = strchr(str, ',');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|   \t\tif (p != NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   99|   \t\t\t*p = '\\0';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 369,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xz/util.c",
                    "line": 156,
                    "event": "error[zerodiv]",
                    "message": "Division by zero.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|   \t\t// Don't overflow here either.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156|-> \t\tif (result > UINT64_MAX / multiplier)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   \t\t\tgoto error;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 171,
                    "event": "error[autoVariables]",
                    "message": "Address of local auto-variable assigned to a function parameter.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  169|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|   \tstrm->avail_in = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|-> \tstrm->next_out = out_buf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|   \tstrm->avail_out = BUFSIZ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 178,
                    "event": "error[autoVariables]",
                    "message": "Address of local auto-variable assigned to a function parameter.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|   \twhile (true) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  177|   \t\tif (strm->avail_in == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|-> \t\t\tstrm->next_in = in_buf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|   \t\t\tstrm->avail_in = fread(in_buf, 1, BUFSIZ, file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 206,
                    "event": "error[uninitvar]",
                    "message": "Uninitialized variable: out_buf",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  204|   \t\t\tconst size_t write_size = BUFSIZ - strm->avail_out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  205|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  206|-> \t\t\tif (fwrite(out_buf, 1, write_size, stdout)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  207|   \t\t\t\t\t!= write_size) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  208|   \t\t\t\t// Wouldn't be a surprise if writing to stderr",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 216,
                    "event": "error[autoVariables]",
                    "message": "Address of local auto-variable assigned to a function parameter.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|   \t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|-> \t\t\tstrm->next_out = out_buf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  217|   \t\t\tstrm->avail_out = BUFSIZ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  218|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 230,
                    "column": 6,
                    "event": "warning[core.StackAddressEscape]",
                    "message": "Address of stack memory associated with local variable 'out_buf' is still referred to by the stack variable 'strm' upon returning to the caller.  This will be a dangling reference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 296,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 296,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 298,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'uncompress'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 160,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'ret' is equal to LZMA_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 160,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 176,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 177,
                    "column": 13,
                    "event": "note",
                    "message": "Field 'avail_in' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 177,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 181,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 181,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 203,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'avail_out' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 203,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 206,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 220,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to LZMA_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 220,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 221,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ret' is equal to LZMA_STREAM_END",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 221,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 224,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'avail_in' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 224,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 224,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 227,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 224,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 230,
                    "column": 6,
                    "event": "note",
                    "message": "Address of stack memory associated with local variable 'out_buf' is still referred to by the stack variable 'strm' upon returning to the caller.  This will be a dangling reference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  228|   \t\t\t\t\tret = LZMA_DATA_ERROR;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  229|   \t\t\t\telse",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  230|-> \t\t\t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  231|   #else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  232|   \t\t\t\t// lzma_stream_decoder() already guarantees",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 237,
                    "column": 5,
                    "event": "warning[core.StackAddressEscape]",
                    "message": "Address of stack memory associated with local variable 'out_buf' is still referred to by the stack variable 'strm' upon returning to the caller.  This will be a dangling reference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 296,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 296,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 298,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'uncompress'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 160,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'ret' is equal to LZMA_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 160,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 176,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 177,
                    "column": 13,
                    "event": "note",
                    "message": "Field 'avail_in' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 177,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 181,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 181,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 193,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 193,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 203,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'avail_out' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 203,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 206,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 220,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to LZMA_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 220,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 221,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ret' is equal to LZMA_STREAM_END",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 221,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "xz-5.4.6/src/xzdec/xzdec.c",
                    "line": 237,
                    "column": 5,
                    "event": "note",
                    "message": "Address of stack memory associated with local variable 'out_buf' is still referred to by the stack variable 'strm' upon returning to the caller.  This will be a dangling reference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  235|   \t\t\t\tassert(action == LZMA_FINISH);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  236|   \t\t\t\tassert(feof(file));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  237|-> \t\t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|   \t\t\t}",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
